/******************************************
 * CONFRONTO DI UN CANALE ANALOGICO       *
 *     tramite un potenziometro           *
 *                                        *
 *       Corso ZIP febbraio 2011          *
 *                                        *
 ******************************************/

#include	<pic.h>
#include	"delay.h"
//#include	"delay.c"
#include	"ADC.h"


#define 	smin	150
#define		smax	1023
#include	"settaggiADC.h"


//Routine principale...


void main(){
	
	settaggiADC();
	
	unsigned int	valore1;
	unsigned int	incr;


	//TRISB=0x00;     //PORTB tutte uscite
	//TRISA=0xFF;     //PORTA tutti ingressi per gli A/D

	/*
		ADCON1
		1 - ADFM Risultato giustificato a destra (0 SX)
		0 - non usato
		0 - non usato
		0 - non usato
		0 - PCFG3 Tutti ingressi analogici
		0 - PCGG2 Vref
		0 - PCFG1 -Vdd
		0 - PCFG0 -Vss
	*/
 
	/*
		ADCON0
		0 - ADCS1 Frequenza oscillatore
		1 - ADCS0 Fosc/8 (1/4Mhz=0.23uS .25*8=2uS minimo 1.6uS)
		0 - CHS2
		0 - CHS1 Seleziona l'ingresso dell'ADC
		0 - CHS0
		0 - ADGO Mettere a 1 per inizio conversione 0 -Fine conversione.
		0 - non usato
		0 - ADON ON/OFF ADC (1 ON) Quando ON consuma!!!
	*/

	ADCON1 = 0b10000000;
	
		incr=(smax-smin)/8;

	while(1){
		
		valore1=leggi_ad(0);
		
		if((valore1>=smin)&&(valore1<=smin+incr)){
			PORTB=0b00000001;
		}
		
		if((valore1>=smin+incr)&&(valore1<=smin+2*incr)){
			PORTB=0b00000011;
		}
		
		if((valore1>=smin+2*incr)&&(valore1<=smin+3*incr)){
			PORTB=0b00000111;
		}
		
		if((valore1>=smin+3*incr)&&(valore1<=smin+4*incr)){
			PORTB=0b00001111;
		}
		
		if((valore1>=smin+4*incr)&&(valore1<=smin+5*incr)){
			PORTB=0b00011111;
		}
		
		if((valore1>=smin+5*incr)&&(valore1<=smin+6*incr)){
			PORTB=0b00111111;
		}
				
		if((valore1>=smin+6*incr)&&(valore1<=smin+7*incr)){
			PORTB=0b01111111;
		}
								
		if((valore1>=smin+7*incr)&&(valore1<=smax)){
			PORTB=0b11111111;
			
		}
	}
			
				
				
}